#include <iostream>
#include <fstream>
#include <vector>
#include <map>

using namespace std;

struct Adat {
	int ho;             //hianyzas honapja
	int nap;            //hianyzas napja
	string nev;         //diak neve
	string bejegyzes;   //I, X, O, N sorozata
	int idb = 0;        //I mennyisege
	int xdb = 0;        //X mennyisege
};

/*4. feladat*/
string hetnapja(int ho, int nap)
{
	string napnev[7] = {"vasarnap", "hetfo", "kedd", "szerda", "csutortok", "pentek", "szombat"};
	const int hoignap[12] = {0, 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 335};
	return napnev[(hoignap[(ho-1)]+nap) % 7];
}

int main()
{
	vector<Adat> naplo;
	//cout << "1. feladat" << endl;
	ifstream fin("naplo.txt");
	string adat;
	int tempho, tempnap;
	while(fin >> adat) {
		if(adat[0] == '#') {
			fin >> tempho>> tempnap;
		} else {
			Adat uj;
			uj.ho = tempho;
			uj.nap = tempnap;
			uj.nev = adat + ' ';
			fin >> adat;
			uj.nev += adat;
			fin >> uj.bejegyzes;
			for(unsigned i = 0; i < 7; ++i) {
				if(uj.bejegyzes[i] == 'I')
					uj.idb++;
				else if(uj.bejegyzes[i] == 'X')
					uj.xdb++;
			}
			naplo.push_back(uj);
		}
	}

	cout << "2. feladat" << endl;
	cout << "A naploban " << naplo.size() << " bejegyzes van." << endl;

	cout << "3. feladat" << endl;
	int igazolt = 0;
	int igtlan = 0;
	for(Adat a: naplo) {
		igazolt += a.xdb;
		igtlan += a.idb;
	}
	cout << "Az igazolt hianyzasok szama " << igazolt << ", az igazolatlanoke " << igtlan << " ora." << endl;

	//cout << "4. feladat" << endl;

	cout << "5. feladat" << endl;
	cout << "A honap sorszama= ", cin >> tempho;
	cout << "A nap sorszama= ", cin >> tempnap;
	cout << "Azon a napon " << hetnapja(tempho, tempnap) << " volt." << endl;

	cout << "6. feladat" << endl;
	int ora, db = 0;
	cout << "A nap neve= ", cin >> adat;
	cout << "Az ora sorszama= ", cin >> ora;
	for(Adat a : naplo) {
		if((a.bejegyzes[ora - 1] == 'I' || a.bejegyzes[ora - 1] == 'X') && hetnapja(a.ho, a.nap) == adat)
			db++;
	}
	cout << "Ekkor osszesen " << db << " ora hianyzas tortent." << endl;

	cout << "7. feladat" << endl;
	map<string, int> statisztika;
	for(Adat a : naplo) {
		statisztika[a.nev] += a.idb + a.xdb;
	}
	auto i = statisztika.begin();
	auto leg = i;
	for(++i; i != statisztika.end(); ++i) {
		if(i->second > leg->second)
			leg = i;
	}
	cout << "A legtobbet hianyzo tanulok:";
	for(auto diak : statisztika) {
		if(diak.second == leg->second )
			cout << " " << diak.first ;
	}
	cout << endl;
	return 0;
}
